    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.net.SocketImpl

    java.lang.Object
       |
       +----java.net.SocketImpl

public abstract class SocketImpl
extends Object
implements SocketOptions

The abstract class `SocketImpl` is a common superclass of all classes that actually implement sockets. It is used to create both client and server sockets.

A "plain" socket implements these methods exactly as described, without attempting to go through a firewall or proxy.

##

address
  The IP address of the remote end of this socket.
fd
  The file descriptor object for this socket.
localport
  The local port number to which this socket is connected.
port
  The port number on the remote host to which this socket is connected.

##

SocketImpl()

##

accept(SocketImpl)
  Accepts a connection.
available()
  Returns the number of bytes that can be read from this socket without blocking.
bind(InetAddress, int)
  Binds this socket to the specified port number on the specified host.
close()
  Closes this socket.
connect(InetAddress, int)
  Connects this socket to the specified port number on the specified host.
connect(String, int)
  Connects this socket to the specified port on the named host.
create(boolean)
  Creates either a stream or a datagram socket.
getFileDescriptor()
  Returns the value of this socket's `fd` field.
getInetAddress()
  Returns the value of this socket's `address` field.
getInputStream()
  Returns an input stream for this socket.
getLocalPort()
  Returns the value of this socket's `localport` field.
getOption(int)
  Fetch the value of an option.
getOutputStream()
  Returns an output stream for this socket.
getPort()
  Returns the value of this socket's `port` field.
listen(int)
  Sets the maximum queue length for incoming connection indications (a request to connect) to the `count` argument.
setOption(int, Object)
  Enable/disable the option specified by optID.
toString()
  Returns the address and port of this socket as a `String`.

##

fd

     protected FileDescriptor fd

  The file descriptor object for this socket.

address

     protected InetAddress address

  The IP address of the remote end of this socket.

port

     protected int port

  The port number on the remote host to which this socket is connected.

localport

     protected int localport

  The local port number to which this socket is connected.

##

SocketImpl

     public SocketImpl()

##

create

     protected abstract void create(boolean stream) throws IOException

  Creates either a stream or a datagram socket.

  Parameters:
    stream - if `true`, create a stream socket; otherwise, create a datagram socket.
  Throws: IOException
    if an I/O error occurs while creating the socket.

connect

     protected abstract void connect(String host,
                                     int port) throws IOException

  Connects this socket to the specified port on the named host.

  Parameters:
    host - the name of the remote host.
    port - the port number.
  Throws: IOException
    if an I/O error occurs when connecting to the remote host.

connect

     protected abstract void connect(InetAddress address,
                                     int port) throws IOException

  Connects this socket to the specified port number on the specified host.

  Parameters:
    address - the IP address of the remote host.
    port - the port number.
  Throws: IOException
    if an I/O error occurs when attempting a connection.

bind

     protected abstract void bind(InetAddress host,
                                  int port) throws IOException

  Binds this socket to the specified port number on the specified host.

  Parameters:
    host - the IP address of the remote host.
    port - the port number.
  Throws: IOException
    if an I/O error occurs when binding this socket.

listen

     protected abstract void listen(int backlog) throws IOException

  Sets the maximum queue length for incoming connection indications (a request to connect) to the `count` argument. If a connection indication arrives when the queue is full, the connection is refused.

  Parameters:
    backlog - the maximum length of the queue.
  Throws: IOException
    if an I/O error occurs when creating the queue.

accept

     protected abstract void accept(SocketImpl s) throws IOException

  Accepts a connection.

  Parameters:
    s - the accepted connection.
  Throws: IOException
    if an I/O error occurs when accepting the connection.

getInputStream

     protected abstract InputStream getInputStream() throws IOException

  Returns an input stream for this socket.

  Returns:
    a stream for reading from this socket.
  Throws: IOException
    if an I/O error occurs when creating the input stream.

getOutputStream

     protected abstract OutputStream getOutputStream() throws IOException

  Returns an output stream for this socket.

  Returns:
    an output stream for writing to this socket.
  Throws: IOException
    if an I/O error occurs when creating the output stream.

available

     protected abstract int available() throws IOException

  Returns the number of bytes that can be read from this socket without blocking.

  Returns:
    the number of bytes that can be read from this socket without blocking.
  Throws: IOException
    if an I/O error occurs when determining the number of bytes available.

close

     protected abstract void close() throws IOException

  Closes this socket.

  Throws: IOException
    if an I/O error occurs when closing this socket.

getFileDescriptor

     protected FileDescriptor getFileDescriptor()

  Returns the value of this socket's `fd` field.

  Returns:
    the value of this socket's `fd` field.
  See Also:
    fd

getInetAddress

     protected InetAddress getInetAddress()

  Returns the value of this socket's `address` field.

  Returns:
    the value of this socket's `address` field.
  See Also:
    address

getPort

     protected int getPort()

  Returns the value of this socket's `port` field.

  Returns:
    the value of this socket's `port` field.
  See Also:
    port

getLocalPort

     protected int getLocalPort()

  Returns the value of this socket's `localport` field.

  Returns:
    the value of this socket's `localport` field.
  See Also:
    localport

toString

     public String toString()

  Returns the address and port of this socket as a `String`.

  Returns:
    a string representation of this socket.
  Overrides:
    toString in class Object

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.